'use strict';

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _kea = require('kea');

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createRealThunks(input, output, dispatch, getState) {
  var actions = {};

  (0, _keys2.default)(output.actions).forEach(function (actionKey) {
    actions[actionKey] = function () {
      var _output$actions;

      return dispatch((_output$actions = output.actions)[actionKey].apply(_output$actions, arguments));
    };
    actions[actionKey].toString = output.actions[actionKey].toString;
  });

  var get = function get(key) {
    return key ? output.selectors[key](getState()) : output.selector(getState());
  };
  var fetch = function fetch() {
    var results = {};

    var keys = Array.isArray(arguments[0]) ? arguments[0] : arguments;

    for (var i = 0; i < keys.length; i++) {
      results[keys[i]] = get(keys[i]);
    }

    return results;
  };

  return input.thunks((0, _extends3.default)({}, output, { actions: actions, dispatch: dispatch, getState: getState, get: get, fetch: fetch }));
}

(0, _kea.activatePlugin)({
  name: 'thunk',

  beforeReduxStore: function beforeReduxStore(options) {
    options.middleware.push(_reduxThunk2.default);
  },

  isActive: function isActive(input) {
    return !!input.thunks;
  },

  afterCreateSingleton: function afterCreateSingleton(input, output) {
    if (output.activePlugins.thunk) {
      var realThunks = void 0;
      var thunkKeys = (0, _keys2.default)(input.thunks(output));
      var thunkFunctions = {};

      thunkKeys.forEach(function (thunkKey) {
        thunkFunctions[thunkKey] = function () {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          return function (dispatch, getState) {
            var _realThunks;

            if (!realThunks) {
              realThunks = createRealThunks(input, output, dispatch, getState);
            }
            return (_realThunks = realThunks)[thunkKey].apply(_realThunks, args);
          };
        };
      });
      output.actions = (0, _assign2.default)({}, output.actions, thunkFunctions);
    }
  }
});